'######################## Dialog Builder Template #########################

    #INCLUDE "generic.inc"

'##########################################################################

FUNCTION WinMain(ByVal Instance      as LONG, _
                 ByVal hPrevInstance as LONG, _
                 lpszCmdLine         as ASCIIZ PTR, _
                 ByVal nCmdShow      as LONG) AS LONG

    hInstance = Instance    ' make instance handle global

    DialogBox hInstance,ByVal 100,0,CodePtr(DlgProc1)

    FUNCTION = 0

END FUNCTION

'##########################################################################

FUNCTION DlgProc1(ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) EXPORT as LONG

  Select Case Msg

      Case %WM_INITDIALOG
        ' ---------------------------------------------------------
        ' The WM_INITDIALOG message is the first one processed as
        ' the dialog box first starts. This is where you put code
        ' that needs to be initialised using the handle (hDlg) that
        ' is passed to the function at startup.
        ' ---------------------------------------------------------

        hWnd = hDlg     ' hWnd is global handle

        ' ---------------------------------------
        ' Set the resource icon to the dialog box
        ' ---------------------------------------
          SendMessage hDlg,%WM_SETICON,1, _
                      LoadIcon(hInstance,ByVal 1)

        ' ----------------------------
        ' Set the title for the dialog
        ' ----------------------------
          SetText hDlg,"Generic"

        ' ----------------------------
        ' Get handles for dialog items
        ' ----------------------------
          h1Button1      = GetDlgItem(hDlg,101)
          h1ListBox1     = GetDlgItem(hDlg,102)

        ' --------------------------------------------------------
        ' Subclass the list box. This function tells the operating
        ' system where the function address is that processes the
        ' messages that are sent to the list box. It does it by
        ' setting the "GWL_WNDPROC" member of the predefined class
        ' for the list box to the function address.
        ' --------------------------------------------------------
          lpListProc1& =SetWindowLong(h1ListBox1,%GWL_WNDPROC,_
                                      ByVal CodePtr(ListProc1))

    ' --------------------------------------
    ' Process the WM_COMMAND message to
    ' trap when the button has been clicked.
    ' --------------------------------------
      Case %WM_COMMAND
        Select Case wParam
          Case 101    ' "OK"        The ID number of the button
            MessageBox hWnd,"OK", _
                       "Control ID = 101",%MB_ICONINFORMATION

        End Select

      Case %WM_CLOSE
         EndDialog hDlg, 0

  END Select

END FUNCTION

'##########################################################################

FUNCTION ListProc1(BYVAL hCtl   as LONG, _
                   BYVAL Msg    as LONG, _
                   BYVAL wParam as LONG, _
                   BYVAL lParam as LONG) EXPORT AS LONG

    ' -------------------------------------------------------
    ' This "subclass" function allows you to process, modify,
    ' respond to messages or just throw them away if you need
    ' to change the default behaviour of the control. The
    ' function "CallWindowProc" passes all of the messages to
    ' the original message handling procedure for the control
    ' for default processing.
    ' -------------------------------------------------------

    Select Case Msg
      Case %WM_LBUTTONDBLCLK
        MessageBox hWnd,"FUNCTION ListProc1","Subclassed List Box",%MB_ICONINFORMATION

    End Select

  FUNCTION=CallWindowProc(ByVal lpListProc1&,hCtl,Msg,wParam,lParam)

END FUNCTION

' ##########################################################################

SUB SetText(hndle as LONG,txt as STRING)

  SendMessage hndle, %WM_SETTEXT, 0, StrPtr(txt)

END SUB

'##########################################################################

FUNCTION GetText(hndle as LONG) as STRING

    LOCAL tl as LONG
    LOCAL Buffer as STRING

    tl=GetWindowTextLength(hndle)
    Buffer=space$(tl+1)
    GetWindowText hndle,ByVal strptr(Buffer),tl+1

    FUNCTION = left$(Buffer,len(Buffer)-1)

END FUNCTION

'##########################################################################

